﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.82
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public SGE As SGE
	Public AM As sgeAssetManager
	Private lstFocusable As List
	Private objFocused As Object
	Private GroupUnderMouse As sgeGroup
End Sub

'---------------------------------------------------------------------------------------
'This module and the other classes of this demo can be compiled to a library with Alt+5.
'---------------------------------------------------------------------------------------

'Initializes the focus manager and the key/mouse event dispatcher.
Public Sub Initialize(SimpleGameEngine As SGE)
	SGE = SimpleGameEngine
End Sub

'Adds the assets for the chosen style to the list of assets to load.
'Supported styles: Glassy, Holo, Metal, Robot, XP.
Public Sub AddAssets(AssetMgr As sgeAssetManager, Style As String)
	'Source: https://github.com/czyzby/gdx-skins/archive/master.zip
	AM = AssetMgr
	Select Style
		Case "Glassy"
			AM.Add(AM.IMAGE, "Glassy_ButtonUp", File.DirAssets, "glassy_button-small.9.png")
			AM.Add(AM.IMAGE, "Glassy_ButtonPressed", File.DirAssets, "glassy_button-small-down.9.png")
			AM.Add(AM.IMAGE, "Glassy_ButtonDown", File.DirAssets, "glassy_button-small-down.9.png")
			AM.Add(AM.IMAGE, "Glassy_CheckboxOff", File.DirAssets, "glassy_checkbox-off.png")
			AM.Add(AM.IMAGE, "Glassy_CheckboxOffPressed", File.DirAssets, "glassy_checkbox-off.png")
			AM.Add(AM.IMAGE, "Glassy_CheckboxOn", File.DirAssets, "glassy_checkbox.png")
			AM.Add(AM.IMAGE, "Glassy_CheckboxOnPressed", File.DirAssets, "glassy_checkbox.png")
			AM.Add(AM.IMAGE, "Glassy_ChoiceButton", File.DirAssets, "glassy_select-box.9.png")
			AM.Add(AM.IMAGE, "Glassy_ChoiceButtonPressed", File.DirAssets, "glassy_select-box-down.9.png")
			AM.Add(AM.IMAGE, "Glassy_EditText_Cursor", File.DirAssets, "glassy_cursor.9.png")
			AM.Add(AM.IMAGE, "Glassy_EditText_Default", File.DirAssets, "glassy_textfield_default.9.png")
			AM.Add(AM.IMAGE, "Glassy_EditText_Focused", File.DirAssets, "glassy_textfield_focused.9.png")
			AM.Add(AM.IMAGE, "Glassy_List", File.DirAssets, "glassy_list.9.png")
			AM.Add(AM.IMAGE, "Glassy_ProgressBar", File.DirAssets, "glassy_progress-bar.9.png")
			AM.Add(AM.IMAGE, "Glassy_ProgressFill", File.DirAssets, "glassy_progress-bar-knob.9.png")
			AM.Add(AM.IMAGE, "Glassy_RadioOff", File.DirAssets, "glassy_radio-button-off.png")
			AM.Add(AM.IMAGE, "Glassy_RadioOffPressed", File.DirAssets, "glassy_radio-button-off.png")
			AM.Add(AM.IMAGE, "Glassy_RadioOn", File.DirAssets, "glassy_radio-button.png")
			AM.Add(AM.IMAGE, "Glassy_RadioOnPressed", File.DirAssets, "glassy_radio-button.png")
			AM.Add(AM.IMAGE, "Glassy_Scrollbar", File.DirAssets, "glassy_vertical-scroll-bar.9.png")
			AM.Add(AM.IMAGE, "Glassy_ScrollbarKnob", File.DirAssets, "glassy_vertical-scroll-knob.9.png")
			AM.Add(AM.IMAGE, "Glassy_Selected", File.DirAssets, "glassy_selected.png")
		Case "Holo"
			AM.Add(AM.IMAGE, "Holo_ButtonUp", File.DirAssets, "holo_btn_default_normal_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_ButtonPressed", File.DirAssets, "holo_btn_default_pressed_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_ButtonDown", File.DirAssets, "holo_btn_default_pressed_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_CheckboxOff", File.DirAssets, "holo_btn_check_off_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_CheckboxOffPressed", File.DirAssets, "holo_btn_check_off_pressed_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_CheckboxOn", File.DirAssets, "holo_btn_check_on_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_CheckboxOnPressed", File.DirAssets, "holo_btn_check_on_pressed_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_ChoiceButton", File.DirAssets, "holo_spinner_colored_normal_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_ChoiceButtonPressed", File.DirAssets, "holo_spinner_colored_pressed_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_EditText_Cursor", File.DirAssets, "holo_cursor.9.png")
			AM.Add(AM.IMAGE, "Holo_EditText_Default", File.DirAssets, "holo_textfield_default_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_EditText_Focused", File.DirAssets, "holo_textfield_activated_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_List", File.DirAssets, "holo_list.9.png")
			AM.Add(AM.IMAGE, "Holo_ProgressBar", File.DirAssets, "holo_progress_bg_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_ProgressFill", File.DirAssets, "holo_progress_primary_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_RadioOff", File.DirAssets, "holo_btn_radio_off_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_RadioOffPressed", File.DirAssets, "holo_btn_radio_off_pressed_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_RadioOn", File.DirAssets, "holo_btn_radio_on_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_RadioOnPressed", File.DirAssets, "holo_btn_radio_on_pressed_holo_light.png")
			AM.Add(AM.IMAGE, "Holo_Scrollbar", File.DirAssets, "holo_progress_vertical_bg_holo_light.9.png")
			AM.Add(AM.IMAGE, "Holo_ScrollbarKnob", File.DirAssets, "holo_fastscroll_thumb_default_holo_v.9.png")
			AM.Add(AM.IMAGE, "Holo_Selected", File.DirAssets, "holo_list_activated_holo.png")
		Case "Metal"
			AM.Add(AM.IMAGE, "Metal_ButtonUp", File.DirAssets, "metal_button.9.png")
			AM.Add(AM.IMAGE, "Metal_ButtonPressed", File.DirAssets, "metal_button-over.9.png")
			AM.Add(AM.IMAGE, "Metal_ButtonDown", File.DirAssets, "metal_button-pressed.9.png")
			AM.Add(AM.IMAGE, "Metal_CheckboxOff", File.DirAssets, "metal_checkbox.png")
			AM.Add(AM.IMAGE, "Metal_CheckboxOffPressed", File.DirAssets, "metal_checkbox-over.png")
			AM.Add(AM.IMAGE, "Metal_CheckboxOn", File.DirAssets, "metal_checkbox-on.png")
			AM.Add(AM.IMAGE, "Metal_CheckboxOnPressed", File.DirAssets, "metal_checkbox-on-over.png")
			AM.Add(AM.IMAGE, "Metal_ChoiceButton", File.DirAssets, "metal_select-box.9.png")
			AM.Add(AM.IMAGE, "Metal_ChoiceButtonPressed", File.DirAssets, "metal_select-box-pressed.9.png")
			AM.Add(AM.IMAGE, "Metal_EditText_Cursor", File.DirAssets, "metal_cursor.9.png")
			AM.Add(AM.IMAGE, "Metal_EditText_Default", File.DirAssets, "metal_rect.9.png")
			AM.Add(AM.IMAGE, "Metal_EditText_Focused", File.DirAssets, "metal_rect.9.png")
			AM.Add(AM.IMAGE, "Metal_List", File.DirAssets, "metal_list.9.png")
			AM.Add(AM.IMAGE, "Metal_ProgressBar", File.DirAssets, "metal_progress-bar.9.png")
			AM.Add(AM.IMAGE, "Metal_ProgressFill", File.DirAssets, "metal_progress-bar-knob.9.png")
			AM.Add(AM.IMAGE, "Metal_RadioOff", File.DirAssets, "metal_radio.png")
			AM.Add(AM.IMAGE, "Metal_RadioOffPressed", File.DirAssets, "metal_radio-over.png")
			AM.Add(AM.IMAGE, "Metal_RadioOn", File.DirAssets, "metal_radio-on.png")
			AM.Add(AM.IMAGE, "Metal_RadioOnPressed", File.DirAssets, "metal_radio-on-hover.png")
			AM.Add(AM.IMAGE, "Metal_Scrollbar", File.DirAssets, "metal_scrollbar-v.9.png")
			AM.Add(AM.IMAGE, "Metal_ScrollbarKnob", File.DirAssets, "metal_scrollbar-v-knob.9.png")
			AM.Add(AM.IMAGE, "Metal_Selected", File.DirAssets, "metal_selection.png")
		Case "Robot"
			AM.Add(AM.IMAGE, "Robot_ButtonUp", File.DirAssets, "robot_button.9.png")
			AM.Add(AM.IMAGE, "Robot_ButtonPressed", File.DirAssets, "robot_button-pressed.9.png")
			AM.Add(AM.IMAGE, "Robot_ButtonDown", File.DirAssets, "robot_button-pressed.9.png")
			AM.Add(AM.IMAGE, "Robot_CheckboxOff", File.DirAssets, "robot_checkbox.png")
			AM.Add(AM.IMAGE, "Robot_CheckboxOffPressed", File.DirAssets, "robot_checkbox.png")
			AM.Add(AM.IMAGE, "Robot_CheckboxOn", File.DirAssets, "robot_checkbox-pressed.png")
			AM.Add(AM.IMAGE, "Robot_CheckboxOnPressed", File.DirAssets, "robot_checkbox-pressed.png")
			AM.Add(AM.IMAGE, "Robot_ChoiceButton", File.DirAssets, "robot_select-box.9.png")
			AM.Add(AM.IMAGE, "Robot_ChoiceButtonPressed", File.DirAssets, "robot_select-box.9.png")
			AM.Add(AM.IMAGE, "Robot_EditText_Cursor", File.DirAssets, "robot_cursor.9.png")
			AM.Add(AM.IMAGE, "Robot_EditText_Default", File.DirAssets, "robot_text-field_default.9.png")
			AM.Add(AM.IMAGE, "Robot_EditText_Focused", File.DirAssets, "robot_text-field_focused.9.png")
			AM.Add(AM.IMAGE, "Robot_List", File.DirAssets, "robot_list.9.png")
			AM.Add(AM.IMAGE, "Robot_ProgressBar", File.DirAssets, "robot_progress-bar-horizontal.9.png")
			AM.Add(AM.IMAGE, "Robot_ProgressFill", File.DirAssets, "robot_progress-bar-knob-horizontal.png")
			AM.Add(AM.IMAGE, "Robot_RadioOff", File.DirAssets, "robot_radio.png")
			AM.Add(AM.IMAGE, "Robot_RadioOffPressed", File.DirAssets, "robot_radio.png")
			AM.Add(AM.IMAGE, "Robot_RadioOn", File.DirAssets, "robot_radio-pressed.png")
			AM.Add(AM.IMAGE, "Robot_RadioOnPressed", File.DirAssets, "robot_radio-pressed.png")
			AM.Add(AM.IMAGE, "Robot_Scrollbar", File.DirAssets, "robot_scrollbar-vertical.9.png")
			AM.Add(AM.IMAGE, "Robot_ScrollbarKnob", File.DirAssets, "robot_scrollbar-knob-vertical.png")
			AM.Add(AM.IMAGE, "Robot_Selected", File.DirAssets, "robot_selected.png")
		Case "XP"
			AM.Add(AM.IMAGE, "XP_ButtonUp", File.DirAssets, "xp_button.9.png")
			AM.Add(AM.IMAGE, "XP_ButtonPressed", File.DirAssets, "xp_button-hover.9.png")
			AM.Add(AM.IMAGE, "XP_ButtonDown", File.DirAssets, "xp_button-pressed.9.png")
			AM.Add(AM.IMAGE, "XP_CheckboxOff", File.DirAssets, "xp_checkbox.png")
			AM.Add(AM.IMAGE, "XP_CheckboxOffPressed", File.DirAssets, "xp_checkbox-hover.png")
			AM.Add(AM.IMAGE, "XP_CheckboxOn", File.DirAssets, "xp_checkbox-pressed.png")
			AM.Add(AM.IMAGE, "XP_CheckboxOnPressed", File.DirAssets, "xp_checkbox-pressed-hover.png")
			AM.Add(AM.IMAGE, "XP_ChoiceButton", File.DirAssets, "xp_select-box.9.png")
			AM.Add(AM.IMAGE, "XP_ChoiceButtonPressed", File.DirAssets, "xp_select-box_down.9.png")
			AM.Add(AM.IMAGE, "XP_EditText_Cursor", File.DirAssets, "xp_cursor.9.png")
			AM.Add(AM.IMAGE, "XP_EditText_Default", File.DirAssets, "xp_textfield_default.9.png")
			AM.Add(AM.IMAGE, "XP_EditText_Focused", File.DirAssets, "xp_textfield_focused.9.png")
			AM.Add(AM.IMAGE, "XP_List", File.DirAssets, "xp_list.9.png")
			AM.Add(AM.IMAGE, "XP_ProgressBar", File.DirAssets, "xp_progressbar.9.png")
			AM.Add(AM.IMAGE, "XP_ProgressFill", File.DirAssets, "xp_progressbar-fill.9.png")
			AM.Add(AM.IMAGE, "XP_RadioOff", File.DirAssets, "xp_radio.png")
			AM.Add(AM.IMAGE, "XP_RadioOffPressed", File.DirAssets, "xp_radio-hover.png")
			AM.Add(AM.IMAGE, "XP_RadioOn", File.DirAssets, "xp_radio-pressed.png")
			AM.Add(AM.IMAGE, "XP_RadioOnPressed", File.DirAssets, "xp_radio-pressed-hover.png")
			AM.Add(AM.IMAGE, "XP_Scrollbar", File.DirAssets, "xp_scroll-background-v.9.png")
			AM.Add(AM.IMAGE, "XP_ScrollbarKnob", File.DirAssets, "xp_scrollbar-knob-v.9.png")
			AM.Add(AM.IMAGE, "XP_Selected", File.DirAssets, "xp_list-selection.png")
	End Select
End Sub

'Sets the list of focusable objects.
Public Sub SetFocusableObjects(Focusable As List, FirstFocused As Object)
	lstFocusable = Focusable
	objFocused = FirstFocused
End Sub

Public Sub GiveFocusTo(Obj As Object)
	'Is the specified object in the list of focusable objects?
	If IsFocusable(Obj) And Obj <> objFocused Then
		'Removes the focus from the focused object
		If objFocused Is clsChoiceBox Then
			Dim CB As clsChoiceBox = objFocused
			CB.RemoveFocus
		Else If objFocused Is clsEditText Then
			Dim Edit As clsEditText = objFocused
			Edit.Activate(False)
		End If

		'Gives the focus to the specified object
		objFocused = Obj
		'Log("Got focus: " & GetType(objFocused))
		If Obj Is clsEditText Then
			Dim Edit As clsEditText = Obj
			Edit.Activate(True)
		End If
	End If
End Sub

'Is the specified object in the list of focusable objects?
Public Sub IsFocusable(Obj As Object) As Boolean
	Return (lstFocusable.IndexOf(Obj) > -1)
End Sub

Public Sub IsFocused(Obj As Object) As Boolean
	Return (objFocused = Obj)
End Sub

Public Sub UIM_KeyPressed(KeyData As sgeKeyEvent)
	'Tab -> gives the focus to the next object in the list
	If KeyData.Code = KeyData.KEY_TAB Then
		Dim Index As Int = lstFocusable.IndexOf(objFocused)
		Index = Index + 1
		If Index >= lstFocusable.Size Then
			Index = 0
		End If
		GiveFocusTo(lstFocusable.Get(Index))
		Return
	End If

	'Dispatches the KeyPressed event
	If objFocused Is clsButton Then
		Dim Btn As clsButton = objFocused
		'Log("Btn.KeyPressed")
		Btn.KeyPressed(KeyData)
	Else If objFocused Is clsCheckbox Then
		Dim ChkBox As clsCheckbox = objFocused
		'Log("Checkbox.KeyPressed")
		ChkBox.KeyPressed(KeyData)
	Else If objFocused Is clsChoiceBox Then
		Dim ChoiceB As clsChoiceBox = objFocused
		'Log("ChoiceBox.KeyPressed")
		ChoiceB.KeyPressed(KeyData)
	Else If objFocused Is clsEditText Then
		Dim Edit As clsEditText = objFocused
		'Log("Edit.KeyPressed")
		Edit.KeyPressed(KeyData)
	Else If objFocused Is clsList Then
		Dim List As clsList = objFocused
		'Log("List.KeyPressed")
		List.KeyPressed(KeyData)
	Else If objFocused Is clsRadioButton Then
		Dim RadioB As clsRadioButton = objFocused
		'Log("RadioB.KeyPressed")
		RadioB.KeyPressed(KeyData)
	End If
End Sub

Public Sub UIM_KeyTyped(UnicodeCharacter As String)
	'Dispatches the KeyTyped event to the focused editor
	If objFocused Is clsEditText Then
		Dim Edit As clsEditText = objFocused
		Edit.KeyTyped(UnicodeCharacter)
	End If
End Sub

Public Sub UIM_KeyReleased(KeyData As sgeKeyEvent)
	'Dispatches the KeyReleased event
	If objFocused Is clsButton Then
		Dim Btn As clsButton = objFocused
		Btn.KeyReleased(KeyData)
	Else If objFocused Is clsCheckbox Then
		Dim ChkBox As clsCheckbox = objFocused
		ChkBox.KeyReleased(KeyData)
	Else If objFocused Is clsChoiceBox Then
		Dim ChoiceB As clsChoiceBox = objFocused
		ChoiceB.KeyReleased(KeyData)
	Else If objFocused Is clsRadioButton Then
		Dim RadioB As clsRadioButton = objFocused
		RadioB.KeyReleased(KeyData)
	End If
End Sub

Private Sub IdentifyGroupUnderMouse(EventData As MouseEvent) As sgeGroup
	'Gets the group with the highest Z-order located at the mouse position
	Dim MousePos As sgePoint2D = SGE.Input.MouseToCanvas(EventData.X, EventData.Y)
	Dim PressedList As List = SGE.Root.FindAtPos2(MousePos, SGE.Root.FIND_ONLY_GROUPS, True, False)
	If PressedList.Size > 0 Then
		Return PressedList.Get(0)
	End If
	Return Null
End Sub

Public Sub UIM_MousePressed(EventData As MouseEvent)
	'Gives the focus and dispatches the MousePressed event
	GroupUnderMouse = IdentifyGroupUnderMouse(EventData)
	If GroupUnderMouse <> Null And GroupUnderMouse.IsInitialized Then
		If GroupUnderMouse.Tag Is clsButton Then
			Dim Btn As clsButton = GroupUnderMouse.Tag
			GiveFocusTo(Btn)
			If objFocused = Btn Then
				'Log("Btn.MousePressed")
				Btn.MousePressed(EventData)
			End If
		Else If GroupUnderMouse.Tag Is clsCheckbox Then
			Dim ChkBox As clsCheckbox = GroupUnderMouse.Tag
			GiveFocusTo(ChkBox)
			If objFocused = ChkBox Then
				'Log("Checkbox.MousePressed")
				ChkBox.MousePressed(EventData)
			End If
		Else If GroupUnderMouse.Tag Is clsChoiceBox Then
			Dim ChoiceBox As clsChoiceBox = GroupUnderMouse.Tag
			GiveFocusTo(ChoiceBox)
			If objFocused = ChoiceBox Then
				'Log("ChoiceBox.MousePressed")
				ChoiceBox.Button_MousePressed(EventData)
			End If
		Else If GroupUnderMouse.Tag Is clsEditText Then
			Dim Edit As clsEditText = GroupUnderMouse.Tag
			GiveFocusTo(Edit)
			If objFocused = Edit Then
				'Log("Edit.MousePressed")
				Edit.MousePressed(EventData)
			End If
		Else If GroupUnderMouse.Tag Is clsList Then
			Dim List As clsList = GroupUnderMouse.Tag
			GiveFocusTo(List)
			If objFocused = List Then
				'Log("List.MousePressed")
				List.MousePressed(EventData)
			Else If objFocused Is clsChoiceBox Then
				'Log("ChoiceBox.List_MousePressed")
				Dim ChoiceBox As clsChoiceBox = objFocused
				ChoiceBox.List_MousePressed(EventData)
			End If
		Else If GroupUnderMouse.Tag Is clsRadioButton Then
			Dim RadioB As clsRadioButton = GroupUnderMouse.Tag
			GiveFocusTo(RadioB)
			If objFocused = RadioB Then
				'Log("RadioB.MousePressed")
				RadioB.MousePressed(EventData)
			End If
		End If
	End If
End Sub

Public Sub UIM_MouseDragged(EventData As MouseEvent)
	'Dispatches the MouseDragged event
	If GroupUnderMouse <> Null And GroupUnderMouse.Tag <> Null Then
		If GroupUnderMouse.Tag Is clsEditText Then
			Dim Edit As clsEditText = GroupUnderMouse.Tag
			'Log("Edit.MouseDragged")
			Edit.MouseDragged(EventData)
		Else If GroupUnderMouse.Tag Is clsList Then
			Dim List As clsList = GroupUnderMouse.Tag
			'Log("List.MouseDragged")
			List.MouseDragged(EventData)
		End If
	End If
End Sub

Public Sub UIM_MouseReleased(EventData As MouseEvent)
	'Dispatches the MouseReleased event
	If GroupUnderMouse <> Null And GroupUnderMouse.Tag <> Null Then
		If GroupUnderMouse.Tag Is clsButton Then
			Dim Btn As clsButton = GroupUnderMouse.Tag
			'Log("Btn.MouseReleased")
			Btn.MouseReleased(EventData)
		Else If GroupUnderMouse.Tag Is clsCheckbox Then
			Dim CB As clsCheckbox = GroupUnderMouse.Tag
			'Log("Checkbox.MouseReleased")
			CB.MouseReleased(EventData)
		Else If GroupUnderMouse.Tag Is clsChoiceBox Then
			Dim ChoiceBox As clsChoiceBox = GroupUnderMouse.Tag
			'Log("ChoiceBox.MouseReleased")
			ChoiceBox.MouseReleased(EventData)
		Else If GroupUnderMouse.Tag Is clsEditText Then
			Dim Edit As clsEditText = GroupUnderMouse.Tag
			'Log("Edit.MouseReleased")
			Edit.MouseReleased(EventData)
		Else If GroupUnderMouse.Tag Is clsList Then
			Dim List As clsList = GroupUnderMouse.Tag
			'Log("List.MouseReleased")
			List.MouseReleased(EventData)
		Else If GroupUnderMouse.Tag Is clsRadioButton Then
			Dim RB As clsRadioButton = GroupUnderMouse.Tag
			'Log("RadioB.MouseReleased")
			RB.MouseReleased(EventData)
		End If
		GroupUnderMouse = Null
	End If
End Sub

Public Sub UIM_Scroll(DeltaY As Double)
	'Dispatches the Scroll event to the focused list
	If objFocused Is clsList Then
		Dim List As clsList = objFocused
		'Log("List.Scroll")
		List.Scroll(DeltaY)
	End If
End Sub
