﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.82
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private State As Boolean
	Private Toggle As Boolean
	Private Pressed As Boolean
	Private BtnStyle As String
	Private BtnImg As sgeActor
	Private Btn_9Patch As sgeNinePatch
	Private Module As Object
	Private Event As String
End Sub

'Creates a button with the specified content (sgeActor or sgeGroup). The content is centered within the button.
'Raises an event with the specified name when the button is clicked.
Public Sub Initialize(Parent As sgeGroup, LocalX As Double, LocalY As Double, Width As Double, Height As Double, Content As Object, CanToggle As Boolean, Style As String, EventModule As Object, EventName As String)
	Dim Grp As sgeGroup
	Grp.Initialize(Parent, "")
	Grp.SetLocalPosition(LocalX, LocalY)
	Grp.Tag = Me
	State = False
	Toggle = CanToggle
	Pressed = False
	BtnStyle = Style
	Update9Patch
	BtnImg.InitializeWithNinePatch(Btn_9Patch, Grp, "")
	BtnImg.SetSize(Width, Height)
	BtnImg.Tag = Me
	If Content Is sgeActor Then
		Dim A As sgeActor = Content
		A.Parent = Grp
		A.SetLocalPosition((Width - A.Width) / 2, (Height - A.Height) / 2)
		A.Tag = Me
	Else
		Dim G As sgeGroup = Content
		G.Parent = Grp
		G.SetLocalPosition((Width - G.Width) / 2, (Height - G.Height) / 2)
		G.Tag = Me
	End If
	Module = EventModule
	Event = EventName
End Sub

Public Sub ChangeStyle(NewStyle As String)
	BtnStyle = NewStyle
	Update9Patch
End Sub

Private Sub Update9Patch
	Dim ImageName As String
	If Pressed Then
		ImageName = BtnStyle & "_ButtonPressed"
	Else
		If State = True Then
			ImageName = BtnStyle & "_ButtonDown"
		Else
			ImageName = BtnStyle & "_ButtonUp"
		End If
	End If
	Btn_9Patch.Initialize(UIManager.AM.SplitNinePatch(ImageName))
End Sub

Public Sub GetDownState As Boolean
	If Toggle Then
		Return State
	Else
		Return False
	End If
End Sub

Public Sub SetDownState(NewState As Boolean)
	If Toggle Then
		State = NewState
	End If
	Update9Patch
	CallSub(Module, Event)
End Sub

Public Sub KeyPressed(KeyData As sgeKeyEvent)
	'Space/Enter: presses the button
	If KeyData.Code = KeyData.KEY_SPACE Or KeyData.Code = KeyData.KEY_ENTER Then
		Pressed = True
		Update9Patch
	End If
End Sub

Public Sub KeyReleased(KeyData As sgeKeyEvent)
	'Space/Enter: changes the button state
	If KeyData.Code = KeyData.KEY_SPACE Or KeyData.Code = KeyData.KEY_ENTER Then
		Pressed = False
		SetDownState(Not(State))
	End If
End Sub

Public Sub MousePressed(EventData As MouseEvent)
	Pressed = True
	Update9Patch
End Sub

Public Sub MouseReleased(EventData As MouseEvent)
	Pressed = False
	SetDownState(Not(State))
End Sub
