﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.82
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private State As Boolean
	Private Pressed As Boolean
	Private CBStyle As String
	Private BoxImg As sgeActor
	Private TextObj As sgeText
	Private TextA As sgeActor
	Private Module As Object
	Private Event As String
End Sub

'Creates a checkbox with the given text. The text is drawn on the right of the box.
'Raises an event with the specified name when the box is clicked.
Public Sub Initialize(Parent As sgeGroup, LocalX As Double, LocalY As Double, MaxWidth As Double, Text As String, Style As String, EventModule As Object, EventName As String)
	Dim Grp As sgeGroup
	Grp.Initialize(Parent, "")
	Grp.SetLocalPosition(LocalX, LocalY)
	Grp.Tag = Me
	State = False
	Pressed = False
	CBStyle = Style
	BoxImg.InitializeWithImage(GetImage, Grp, "")
	BoxImg.Tag = Me
	TextObj.Initialize(Text, fx.DefaultFont(16))
	TextObj.MaxWidth = MaxWidth
	TextA.InitializeWithText(TextObj, Grp, "")
	TextA.Tag = Me
	SetPositions
	Module = EventModule
	Event = EventName
End Sub

Private Sub SetPositions
	TextA.LocalX = BoxImg.Width
	If TextObj.TextHeight > BoxImg.Height Then
		BoxImg.LocalY = (TextObj.TextHeight - BoxImg.Height) / 2
		TextA.LocalY = 0
	Else If TextObj.TextHeight < BoxImg.Height Then
		BoxImg.LocalY = 0
		TextA.LocalY = (BoxImg.Height - TextObj.TextHeight) / 2
	End If
End Sub

Private Sub GetImage As Image
	Dim ImageName As String
	If State = True Then
		If Pressed Then
			ImageName = "_CheckboxOnPressed"
		Else
			ImageName = "_CheckboxOn"
		End If
	Else
		If Pressed Then
			ImageName = "_CheckboxOffPressed"
		Else
			ImageName = "_CheckboxOff"
		End If
	End If
	Return UIManager.AM.GetImage(CBStyle & ImageName)
End Sub

Public Sub ChangeStyle(NewStyle As String)
	CBStyle = NewStyle
	Dim NewImage As Image = GetImage
	BoxImg.SetImage(NewImage)
	BoxImg.SetSize(NewImage.Width, NewImage.Height)
	SetPositions
End Sub

Public Sub GetChecked As Boolean
	Return State
End Sub

Public Sub SetChecked(NewState As Boolean)
	If State <> NewState Then
		State = NewState
		BoxImg.SetImage(GetImage)
		CallSub(Module, Event)
	Else
		BoxImg.SetImage(GetImage)
	End If
End Sub

Public Sub KeyPressed(KeyData As sgeKeyEvent)
	'Space/Enter: presses the button
	If KeyData.Code = KeyData.KEY_SPACE Or KeyData.Code = KeyData.KEY_ENTER Then
		Pressed = True
		BoxImg.SetImage(GetImage)
	End If
End Sub

Public Sub KeyReleased(KeyData As sgeKeyEvent)
	'Space/Enter: changes the button state
	If KeyData.Code = KeyData.KEY_SPACE Or KeyData.Code = KeyData.KEY_ENTER Then
		Pressed = False
		SetChecked(Not(State))
	End If
End Sub

Public Sub MousePressed(EventData As MouseEvent)
	Pressed = True
	BoxImg.SetImage(GetImage)
End Sub

Public Sub MouseReleased(EventData As MouseEvent)
	Pressed = False
	SetChecked(Not(State))
End Sub
