﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.82
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private Grp As sgeGroup
	Private BkgdImg As sgeActor
	Private Bkgd_9Patch As sgeNinePatch
	Private GrpFill As sgeGroup
	Private FillImg As sgeActor
	Private Fill_9Patch As sgeNinePatch
	Private InitialHeight As Double
	Private Progression As Double
	Private PBStyle As String
End Sub

'Creates a horizontal progress bar.
Public Sub Initialize(Parent As sgeGroup, LocalX As Double, LocalY As Double, Width As Double, Height As Double, Style As String)
	Grp.Initialize(Parent, "")
	Grp.SetLocalPosition(LocalX, LocalY)
	Grp.Tag = Me
	InitialHeight = Height
	Progression = 0
	PBStyle = Style
	LoadAssets
	BkgdImg.InitializeWithNinePatch(Bkgd_9Patch, Grp, "")
	BkgdImg.SetSize(Width, Height)
	GrpFill.Initialize(Grp, "")
	GrpFill.Tag = Me
	FillImg.InitializeWithNinePatch(Fill_9Patch, GrpFill, "")
	FillImg.LocalX = 1
	UpdateUI
End Sub

Private Sub LoadAssets
	Bkgd_9Patch.Initialize(UIManager.AM.SplitNinePatch(PBStyle & "_ProgressBar"))
	Fill_9Patch.Initialize(UIManager.AM.SplitNinePatch(PBStyle & "_ProgressFill"))
End Sub

Private Sub UpdateUI
	BkgdImg.Height = Max(InitialHeight, Bkgd_9Patch.MinHeight)

	GrpFill.LocalX = Bkgd_9Patch.FirstColumnWidth - 2
	GrpFill.LocalY = Bkgd_9Patch.FirstRowHeight - 3

	FillImg.Width = BkgdImg.Width - Bkgd_9Patch.FirstColumnWidth - Bkgd_9Patch.LastColumnWidth + 2
	FillImg.Height = BkgdImg.Height - Bkgd_9Patch.FirstRowHeight - Bkgd_9Patch.LastRowHeight + 5

	SetProgression(Progression)
End Sub

Public Sub ChangeStyle(NewStyle As String)
	PBStyle = NewStyle
	LoadAssets
	UpdateUI
End Sub

Public Sub GetProgression As Double
	Return Progression
End Sub

Public Sub SetProgression(From0To1 As Double)
	Progression = From0To1
	GrpFill.SetClipBounds(0, 0, FillImg.Width * Progression + 1, FillImg.Height)
End Sub
