﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.82
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private State As Boolean
	Private Pressed As Boolean
	Private RBStyle As String
	Private Grp As sgeGroup
	Private BtnImg As sgeActor
	Private TextObj As sgeText
	Private TextA As sgeActor
	Private Module As Object
	Private Event As String
End Sub

'Creates a radio button with the given text. The text is drawn on the right of the button.
'When this button is checked, all other radio buttons with the same parent become unchecked.
'Raises an event with the specified name when the button is clicked.
Public Sub Initialize(Parent As sgeGroup, LocalX As Double, LocalY As Double, MaxWidth As Double, Text As String, Style As String, EventModule As Object, EventName As String)
	Grp.Initialize(Parent, "")
	Grp.SetLocalPosition(LocalX, LocalY)
	Grp.Tag = Me
	State = False
	Pressed = False
	RBStyle = Style
	BtnImg.InitializeWithImage(GetImage, Grp, "")
	BtnImg.Tag = Me
	TextObj.Initialize(Text, fx.DefaultFont(16))
	TextObj.MaxWidth = MaxWidth
	TextA.InitializeWithText(TextObj, Grp, "")
	TextA.Tag = Me
	SetPositions
	Module = EventModule
	Event = EventName
End Sub

Private Sub GetImage As Image
	Dim ImageName As String
	If State = True Then
		If Pressed Then
			ImageName = "_RadioOnPressed"
		Else
			ImageName = "_RadioOn"
		End If
	Else
		If Pressed Then
			ImageName = "_RadioOffPressed"
		Else
			ImageName = "_RadioOff"
		End If
	End If
	Return UIManager.AM.GetImage(RBStyle & ImageName)
End Sub

Private Sub SetPositions
	TextA.LocalX = BtnImg.Width
	If TextObj.TextHeight > BtnImg.Height Then
		BtnImg.LocalY = (TextObj.TextHeight - BtnImg.Height) / 2
		TextA.LocalY = 0
	Else If TextObj.TextHeight < BtnImg.Height Then
		BtnImg.LocalY = 0
		TextA.LocalY = (BtnImg.Height - TextObj.TextHeight) / 2
	End If
End Sub

Public Sub ChangeStyle(NewStyle As String)
	RBStyle = NewStyle
	Dim NewImage As Image = GetImage
	BtnImg.SetImage(NewImage)
	BtnImg.SetSize(NewImage.Width, NewImage.Height)
	SetPositions
End Sub

Public Sub GetSelected As Boolean
	Return State
End Sub

Private Sub RaiseEvent
	CallSub(Module, Event)
End Sub

Public Sub SetSelected(NewState As Boolean)
	If State <> NewState Then
		State = NewState
		BtnImg.SetImage(GetImage)
		If State = True Then
			For i = 0 To Grp.Parent.Children.Size - 1
				Dim O As Object = Grp.Parent.Children.Get(i)
				If O Is sgeGroup Then
					Dim G As sgeGroup = O
					If G.Tag Is clsRadioButton And G.Tag <> Me Then
						Dim RB As clsRadioButton = G.Tag
						If RB.State <> False Then
							RB.State = False
							RB.BtnImg.SetImage(RB.GetImage)
							RB.RaiseEvent
						End If
					End If
				End If
			Next
		End If
		RaiseEvent
	Else
		BtnImg.SetImage(GetImage)
	End If
End Sub

Public Sub KeyPressed(KeyData As sgeKeyEvent)
	'Space/Enter: presses the button
	If KeyData.Code = KeyData.KEY_SPACE Or KeyData.Code = KeyData.KEY_ENTER Then
		Pressed = True
		BtnImg.SetImage(GetImage)
	End If
End Sub

Public Sub KeyReleased(KeyData As sgeKeyEvent)
	'Space/Enter: changes the button state
	If KeyData.Code = KeyData.KEY_SPACE Or KeyData.Code = KeyData.KEY_ENTER Then
		Pressed = False
		SetSelected(True)
	End If
End Sub

Public Sub MousePressed(EventData As MouseEvent)
	Pressed = True
	BtnImg.SetImage(GetImage)
End Sub

Public Sub MouseReleased(EventData As MouseEvent)
	Pressed = False
	SetSelected(True)
End Sub
